import java.util.*;
import java.lang.String;
import java.lang.Integer;
import java.util.ArrayList;

public class IntegerDuplicateDeleter extends DuplicateDeleter<Integer>{

    public IntegerDuplicateDeleter(Integer[] array){
        super(array);
    }

    public Integer[] removeDuplicates(int maxNumberOfDuplications){
        Integer[] answer = new Integer[array.length];
        int answerIndex = 0;
        for(int i = 0; i<array.length; i++){
            Integer occurences = getAppearances(array[i]);
            if(occurences < maxNumberOfDuplications){
                answer[answerIndex] = array[i];
                answerIndex++;
            }
        }
        Integer[] realAnswer = Arrays.copyOf(answer, answerIndex);
        return realAnswer;
    }

    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications){
        Integer[] answer = new Integer[array.length];
        int answerIndex = 0;
        for(int i = 0; i<array.length; i++){
            Integer occurences = getAppearances(array[i]);
            if(occurences < exactNumberOfDuplications || occurences > exactNumberOfDuplications){
                answer[answerIndex] = array[i];
                answerIndex++;
            }
        }
        Integer[] realAnswer = Arrays.copyOf(answer, answerIndex);
        return realAnswer;
    }
    

    public int getAppearances(Integer value){
        int appearances = 0;
        for (Integer element:array){
            if (element == value){
                appearances++;}
        }
        return appearances;
    }
}
